/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.component.framework.junit.impl;

import java.util.logging.Logger;

import org.ow2.petals.component.framework.junit.Configuration;

/**
 * @author Marc Jambert - EBM WebSourcing
 */
public final class ComponentConfiguration extends Configuration {

    private final Logger logger;

    private final String configurationName;

    public ComponentConfiguration(final String configurationName) {
        this.configurationName = configurationName;
        this.logger = Logger.getLogger("org.ow2.petals.component.framework." + configurationName);
    }
    
    public Logger getLogger() {
        return logger;
    }

    public String getConfigurationName() {
        return configurationName;
    }
}
